/*      Compiler: ECL 24.5.10                                         */
/*      Source: /home/abuild/rpmbuild/BUILD/ecl-24.5.10/src/cmp/cmpbackend-cxx/cmpc-mach.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmpc-mach.eclh"
/*      function definition for MAKE-MACHINE                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3591make_machine(cl_narg narg, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_object v1;
  cl_object v2;
  cl_object v3;
  cl_object v4;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  {
   cl_object keyvars[8];
   cl_parse_key(args,4,L3591make_machinekeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v1 = keyvars[0];
   v2 = keyvars[1];
   v3 = keyvars[2];
   v4 = keyvars[3];
  }
  value0 = si_make_structure(5, VV[3], v1, v2, v3, v4);
  return value0;
 }
}
/*      local function LAMBDA1                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3592__lambda1(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(3), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(3));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA5                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3593__lambda5(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(2), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(2));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA9                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3594__lambda9(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(1), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(1));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA13                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3595__lambda13(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(0), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[0]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(0));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      function definition for %MAKE-REP-TYPE                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3596_make_rep_type(cl_narg narg, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_object v1;
  cl_object v2;
  cl_object v3;
  cl_object v4;
  cl_object v5;
  cl_object v6;
  cl_object v7;
  cl_object v8;
  cl_object v9;
  cl_object v10;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  {
   cl_object keyvars[20];
   cl_parse_key(args,10,L3596_make_rep_typekeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   if (Null(keyvars[10])) {
    v1 = ecl_make_fixnum(0);
   } else {
    v1 = keyvars[0];
   }
   if (Null(keyvars[11])) {
    v2 = ECL_T;
   } else {
    v2 = keyvars[1];
   }
   if (Null(keyvars[12])) {
    v3 = ECL_T;
   } else {
    v3 = keyvars[2];
   }
   v4 = keyvars[3];
   v5 = keyvars[4];
   v6 = keyvars[5];
   v7 = keyvars[6];
   v8 = keyvars[7];
   v9 = keyvars[8];
   v10 = keyvars[9];
  }
  value0 = si_make_structure(11, VV[13], v1, v2, v3, v4, v5, v6, v7, v8, v9, v10);
  return value0;
 }
}
/*      local function LAMBDA17                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3597__lambda17(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(9), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(9));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA21                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3598__lambda21(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(8), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(8));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA25                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3599__lambda25(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(7), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(7));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA29                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3600__lambda29(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(6), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(6));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA33                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3601__lambda33(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(5), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(5));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA37                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3602__lambda37(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(4), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(4));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA41                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3603__lambda41(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(3), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(3));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA45                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3604__lambda45(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(2), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(2));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA49                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3605__lambda49(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(1), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(1));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function LAMBDA53                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3606__lambda53(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1524), v2si__x, T0, ecl_make_fixnum(0), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[10]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1174), v2si__x, T2, ecl_make_fixnum(0));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      function definition for LISP-TYPE-P                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3607lisp_type_p(cl_object v1type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = cl_subtypep(2, v1type, ECL_T);
  return value0;
 }
}
/*      function definition for REP-TYPE-RECORD-UNSAFE                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3608rep_type_record_unsafe(cl_object v1rep_type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_function_dispatch(cl_env_copy,VV[8])(1, ecl_symbol_value(VV[26])) /*  MACHINE-REP-TYPE-HASH */;
  value0 = cl_gethash(2, v1rep_type, T0);
  return value0;
 }
}
/*      function definition for REP-TYPE-RECORD                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3609rep_type_record(cl_object v1rep_type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2record;
   T0 = ecl_function_dispatch(cl_env_copy,VV[8])(1, ecl_symbol_value(VV[26])) /*  MACHINE-REP-TYPE-HASH */;
   v2record = ecl_gethash_safe(v1rep_type,T0,ECL_NIL);
   if (Null(v2record)) { goto L2; }
   value0 = v2record;
   cl_env_copy->nvalues = 1;
   return value0;
L2:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[82])(2, VV[28], v1rep_type) /*  CMPERR */;
   return value0;
  }
 }
}
/*      function definition for REP-TYPE->LISP-TYPE                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3610rep_type__lisp_type(cl_object v1name)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2output;
   v2output = L3608rep_type_record_unsafe(v1name);
   if (Null(v2output)) { goto L2; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[22])(1, v2output) /*  REP-TYPE-LISP-TYPE */;
   return value0;
L2:;
   if (Null(L3607lisp_type_p(v1name))) { goto L4; }
   value0 = v1name;
   cl_env_copy->nvalues = 1;
   return value0;
L4:;
   value0 = cl_error(2, VV[30], v1name);
   return value0;
  }
 }
}
/*      function definition for LISP-TYPE->REP-TYPE                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3611lisp_type__rep_type(cl_object v1type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(v1type==ECL_NIL)) { goto L1; }
  value0 = ECL_SYM("OBJECT",1312);
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  {
   cl_object v2;
   {
    cl_object v3r;
    v3r = L3608rep_type_record_unsafe(v1type);
    if (Null(v3r)) { goto L6; }
    v2 = ecl_function_dispatch(cl_env_copy,VV[23])(1, v3r) /*  REP-TYPE-NAME */;
    goto L3;
L6:;
    v2 = ECL_NIL;
    goto L3;
   }
L3:;
   if (Null(v2)) { goto L8; }
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
L8:;
   {
    cl_object v3;
    v3 = ecl_function_dispatch(cl_env_copy,VV[7])(1, ecl_symbol_value(VV[26])) /*  MACHINE-SORTED-TYPES */;
    goto L13;
L12:;
    {
     cl_object v4record;
     v4record = ecl_car(v3);
     T0 = ecl_function_dispatch(cl_env_copy,VV[22])(1, v4record) /*  REP-TYPE-LISP-TYPE */;
     if (Null(cl_subtypep(2, v1type, T0))) { goto L17; }
     value0 = ecl_function_dispatch(cl_env_copy,VV[23])(1, v4record) /*  REP-TYPE-NAME */;
     return value0;
L17:;
    }
    v3 = ecl_cdr(v3);
L13:;
    if (Null(v3)) { goto L21; }
    goto L12;
L21:;
    value0 = ECL_SYM("OBJECT",1312);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for C-NUMBER-REP-TYPE-P                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3612c_number_rep_type_p(cl_object v1rep_type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2r;
   v2r = L3608rep_type_record_unsafe(v1rep_type);
   if (Null(v2r)) { goto L3; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[20])(1, v2r) /*  REP-TYPE-NUMBERP */;
   return value0;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C-INTEGER-REP-TYPE-P                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3613c_integer_rep_type_p(cl_object v1rep_type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2r;
   v2r = L3608rep_type_record_unsafe(v1rep_type);
   if (Null(v2r)) { goto L3; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[19])(1, v2r) /*  REP-TYPE-INTEGERP */;
   return value0;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C-INTEGER-REP-TYPE-BITS               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3614c_integer_rep_type_bits(cl_object v1rep_type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2r;
   v2r = L3608rep_type_record_unsafe(v1rep_type);
   if (Null(v2r)) { goto L3; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[21])(1, v2r) /*  REP-TYPE-BITS */;
   return value0;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C-NUMBER-TYPE-P                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3615c_number_type_p(cl_object v1type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = L3611lisp_type__rep_type(v1type);
  value0 = L3612c_number_rep_type_p(T0);
  return value0;
 }
}
/*      function definition for C-INTEGER-TYPE-P                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3616c_integer_type_p(cl_object v1type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = L3611lisp_type__rep_type(v1type);
  value0 = L3613c_integer_rep_type_p(T0);
  return value0;
 }
}
/*      function definition for C-INTEGER-TYPE-BITS                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3617c_integer_type_bits(cl_object v1type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = L3611lisp_type__rep_type(v1type);
  value0 = ecl_function_dispatch(cl_env_copy,VV[91])(1, T0) /*  C-NUMBER-REP-TYPE-BITS */;
  return value0;
 }
}
/*      function definition for REP-TYPE->C-NAME                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3618rep_type__c_name(cl_object v1type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = L3609rep_type_record(v1type);
  value0 = ecl_function_dispatch(cl_env_copy,VV[18])(1, T0) /*  REP-TYPE-C-NAME */;
  return value0;
 }
}
/*      function definition for MAKE-REP-TYPE                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3619make_rep_type(cl_narg narg, cl_object v1all_c_types, cl_object v2name, cl_object v3lisp_type, cl_object v4c_name, ...)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<4)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>7)) FEwrong_num_arguments_anonym();
 {
  cl_object v5to_lisp;
  cl_object v6from_lisp;
  cl_object v7from_lisp_unsafe;
  va_list args; va_start(args,v4c_name);
  {
   int i = 4;
   if (i >= narg) {
    v5to_lisp = ECL_NIL;
   } else {
    i++;
    v5to_lisp = va_arg(args,cl_object);
   }
   if (i >= narg) {
    v6from_lisp = ECL_NIL;
   } else {
    i++;
    v6from_lisp = va_arg(args,cl_object);
   }
   if (i >= narg) {
    v7from_lisp_unsafe = ECL_NIL;
   } else {
    i++;
    v7from_lisp_unsafe = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v8record;
   cl_object v9bits;
   {
    cl_object v10;
    cl_object v11;
    v10 = v2name;
    v11 = v1all_c_types;
    v8record = ecl_assql(v10,v11);
   }
   v9bits = ecl_cdr(v8record);
   if (Null(v8record)) { goto L8; }
   if (Null(v9bits)) { goto L10; }
   if (!(ecl_plusp(v9bits))) { goto L12; }
   v3lisp_type = cl_list(2, ECL_SYM("UNSIGNED-BYTE",887), v9bits);
   goto L10;
L12:;
   v9bits = ecl_negate(v9bits);
   v3lisp_type = cl_list(2, ECL_SYM("SIGNED-BYTE",763), v9bits);
L10:;
   T0 = cl_subtypep(2, v3lisp_type, ECL_SYM("NUMBER",608));
   T1 = cl_subtypep(2, v3lisp_type, ECL_SYM("INTEGER",439));
   value0 = L3596_make_rep_type(18, ECL_SYM("NAME",1306), v2name, VV[43], v3lisp_type, VV[44], v9bits, VV[45], T0, VV[46], T1, VV[47], v4c_name, VV[48], v5to_lisp, VV[49], v6from_lisp, VV[50], v7from_lisp_unsafe);
   return value0;
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for DEFAULT-MACHINE                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3620default_machine()
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1all_c_types;
   cl_object v2table;
   cl_object v3sorted_rep_types;
   v1all_c_types = ecl_append(ecl_symbol_value(VV[41]),ecl_symbol_value(VV[42]));
   v2table = cl_make_hash_table(4, ECL_SYM("SIZE",1342), ecl_make_fixnum(128), ECL_SYM("TEST",1350), ECL_SYM("EQ",335));
   {
    cl_object v4i;
    v4i = ecl_make_fixnum(0);
    {
     cl_object v5;
     cl_object v6record;
     cl_object v7;
     v5 = ecl_symbol_value(VV[40]);
     v6record = ECL_NIL;
     {
      cl_object v8;
      v8 = v5;
      value0 = ecl_make_bool(ECL_LISTP(v8));
      if ((value0)!=ECL_NIL) { goto L12; }
      T0 = ecl_make_bool(ECL_SYMBOLP(v8));
      goto L10;
L12:;
      T0 = value0;
      goto L10;
L10:;
      if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[52],v8);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v7 = v8;
     }
     {
      cl_object v8rep_type;
      v8rep_type = ECL_NIL;
      {
       cl_object v9;
       cl_object v10;
       v9 = ecl_list1(ECL_NIL);
       v10 = v9;
L17:;
       v6record = ECL_CONS_CAR(v7);
       {
        cl_object v11;
        v11 = ECL_CONS_CDR(v7);
        value0 = ecl_make_bool(ECL_LISTP(v11));
        if ((value0)!=ECL_NIL) { goto L27; }
        T0 = ecl_make_bool(ECL_SYMBOLP(v11));
        goto L25;
L27:;
        T0 = value0;
        goto L25;
L25:;
        if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[52],v11);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v7 = v11;
       }
       T0 = ecl_fdefinition(VV[51]);
       v8rep_type = cl_apply(3, T0, v1all_c_types, v6record);
       if (Null(v8rep_type)) { goto L32; }
       ecl_structure_set(v8rep_type,VV[10],0,v4i);
       {
        cl_object v11;
        v11 = v10;
        if (ecl_unlikely(ECL_ATOM(v11))) FEtype_error_cons(v11);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        T0 = v11;
       }
       T1 = ecl_function_dispatch(cl_env_copy,VV[23])(1, v8rep_type) /*  REP-TYPE-NAME */;
       T2 = si_hash_set(T1, v2table, v8rep_type);
       v10 = ecl_list1(T2);
       (ECL_CONS_CDR(T0)=v10,T0);
L32:;
       v4i = ecl_one_plus(v4i);
       if (!(ecl_endp(v7))) { goto L41; }
       goto L18;
L41:;
       goto L17;
L18:;
       v3sorted_rep_types = ecl_cdr(v9);
       goto L3;
      }
     }
    }
   }
L3:;
   {
    cl_object v4r;
    v4r = ecl_gethash_safe(VV[53],v2table,ECL_NIL);
    if (Null(v4r)) { goto L45; }
    ecl_structure_set(v4r,VV[10],0,ECL_SYM("INT-SSE-PACK",1900));
   }
L45:;
   {
    cl_object v4fixnum_rep_type;
    v4fixnum_rep_type = ecl_gethash_safe(ECL_SYM("FIXNUM",1406),v2table,ECL_NIL);
    {
     cl_object v5fixnum_lisp_type;
     v5fixnum_lisp_type = ecl_function_dispatch(cl_env_copy,VV[22])(1, v4fixnum_rep_type) /*  REP-TYPE-LISP-TYPE */;
     {
      cl_object v6;
      cl_object v7name;
      cl_object v8rest;
      cl_object v9;
      v6 = ecl_symbol_value(VV[40]);
      v7name = ECL_NIL;
      v8rest = ECL_NIL;
      {
       cl_object v10;
       v10 = v6;
       value0 = ecl_make_bool(ECL_LISTP(v10));
       if ((value0)!=ECL_NIL) { goto L59; }
       T0 = ecl_make_bool(ECL_SYMBOLP(v10));
       goto L57;
L59:;
       T0 = value0;
       goto L57;
L57:;
       if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[52],v10);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v9 = v10;
      }
      {
       cl_object v10r;
       v10r = ECL_NIL;
L62:;
       {
        cl_object v11;
        v11 = ECL_CONS_CAR(v9);
        v7name = ecl_car(v11);
        v11 = ecl_cdr(v11);
        v8rest = v11;
       }
       {
        cl_object v11;
        v11 = ECL_CONS_CDR(v9);
        value0 = ecl_make_bool(ECL_LISTP(v11));
        if ((value0)!=ECL_NIL) { goto L77; }
        T0 = ecl_make_bool(ECL_SYMBOLP(v11));
        goto L75;
L77:;
        T0 = value0;
        goto L75;
L75:;
        if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[52],v11);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v9 = v11;
       }
       v10r = ecl_gethash_safe(v7name,v2table,ECL_NIL);
       if (Null(v10r)) { goto L81; }
       T0 = ecl_function_dispatch(cl_env_copy,VV[22])(1, v10r) /*  REP-TYPE-LISP-TYPE */;
       if (Null(cl_subtypep(2, T0, v5fixnum_lisp_type))) { goto L81; }
       ecl_structure_set(v10r,VV[10],9,VV[54]);
L81:;
       if (!(ecl_endp(v9))) { goto L84; }
       goto L63;
L84:;
       goto L62;
L63:;
      }
     }
    }
   }
   value0 = L3591make_machine(6, VV[55], v1all_c_types, VV[56], v2table, VV[57], v3sorted_rep_types);
   return value0;
  }
 }
}
/*      function definition for MACHINE-C-TYPE-P                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3621machine_c_type_p(cl_object v1name)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_function_dispatch(cl_env_copy,VV[8])(1, ecl_symbol_value(VV[26])) /*  MACHINE-REP-TYPE-HASH */;
  value0 = cl_gethash(2, v1name, T0);
  return value0;
 }
}
/*      function definition for MACHINE-FIXNUMP                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3622machine_fixnump(cl_object v1number)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_gethash(2, ECL_SYM("FIXNUM",1406), v1number);
  T1 = ecl_function_dispatch(cl_env_copy,VV[22])(1, T0) /*  REP-TYPE-LISP-TYPE */;
  value0 = cl_typep(2, v1number, T1);
  return value0;
 }
}

#include "cmp/cmpc-mach.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclzyDq6XRlAR3j9_UDmzvY71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPBACKEND-CXX;CMPC-MACH.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclzyDq6XRlAR3j9_UDmzvY71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  ecl_function_dispatch(cl_env_copy,VV[62])(15, VV[0], _ecl_static_1, ECL_NIL, ECL_NIL, VVtemp[0], VVtemp[1], VV[1], ECL_NIL, ECL_NIL, ECL_NIL, VVtemp[2], ecl_make_fixnum(4), ECL_NIL, ECL_NIL, VV[2]) /*  DEFINE-STRUCTURE */;
  VV[3]= cl_find_class(1, VV[0]);
  ecl_cmp_defun(VV[63]);                          /*  MAKE-MACHINE    */
  {
   cl_object v1package;
   v1package = cl_symbol_package(VV[5]);
   if (Null(v1package)) { goto L9; }
   if (Null(si_package_locked_p(v1package))) { goto L9; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L9; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[5], ECL_SYM("PACKAGE",1318), v1package);
  }
L9:;
  {
   cl_object volatile v2;
   v2 = ecl_make_cfun((cl_objectfn_fixed)LC3592__lambda1,ECL_NIL,Cblock,2);
   T0 = v2;
  }
  si_put_sysprop(VV[5], VV[6], T0);
  {
   cl_object v2package;
   v2package = cl_symbol_package(VV[7]);
   if (Null(v2package)) { goto L17; }
   if (Null(si_package_locked_p(v2package))) { goto L17; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L17; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[6], ECL_SYM("PACKAGE",1318), v2package);
  }
L17:;
  {
   cl_object volatile v3;
   v3 = ecl_make_cfun((cl_objectfn_fixed)LC3593__lambda5,ECL_NIL,Cblock,2);
   T0 = v3;
  }
  si_put_sysprop(VV[7], VV[6], T0);
  {
   cl_object v3package;
   v3package = cl_symbol_package(VV[8]);
   if (Null(v3package)) { goto L25; }
   if (Null(si_package_locked_p(v3package))) { goto L25; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L25; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[7], ECL_SYM("PACKAGE",1318), v3package);
  }
L25:;
  {
   cl_object volatile v4;
   v4 = ecl_make_cfun((cl_objectfn_fixed)LC3594__lambda9,ECL_NIL,Cblock,2);
   T0 = v4;
  }
  si_put_sysprop(VV[8], VV[6], T0);
  {
   cl_object v4package;
   v4package = cl_symbol_package(VV[9]);
   if (Null(v4package)) { goto L33; }
   if (Null(si_package_locked_p(v4package))) { goto L33; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L33; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[8], ECL_SYM("PACKAGE",1318), v4package);
  }
L33:;
  {
   cl_object volatile v5;
   v5 = ecl_make_cfun((cl_objectfn_fixed)LC3595__lambda13,ECL_NIL,Cblock,2);
   T0 = v5;
  }
  si_put_sysprop(VV[9], VV[6], T0);
 }
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  ecl_function_dispatch(cl_env_copy,VV[62])(15, VV[10], _ecl_static_2, ECL_NIL, ECL_NIL, VVtemp[9], VVtemp[10], VV[11], ECL_NIL, ECL_NIL, ECL_NIL, VVtemp[11], ecl_make_fixnum(10), ECL_NIL, ECL_NIL, VV[12]) /*  DEFINE-STRUCTURE */;
  VV[13]= cl_find_class(1, VV[10]);
  ecl_cmp_defun(VV[68]);                          /*  %MAKE-REP-TYPE  */
  {
   cl_object v1package;
   v1package = cl_symbol_package(VV[15]);
   if (Null(v1package)) { goto L49; }
   if (Null(si_package_locked_p(v1package))) { goto L49; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L49; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[12], ECL_SYM("PACKAGE",1318), v1package);
  }
L49:;
  {
   cl_object volatile v2;
   v2 = ecl_make_cfun((cl_objectfn_fixed)LC3597__lambda17,ECL_NIL,Cblock,2);
   T0 = v2;
  }
  si_put_sysprop(VV[15], VV[6], T0);
  {
   cl_object v2package;
   v2package = cl_symbol_package(VV[16]);
   if (Null(v2package)) { goto L57; }
   if (Null(si_package_locked_p(v2package))) { goto L57; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L57; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[13], ECL_SYM("PACKAGE",1318), v2package);
  }
L57:;
  {
   cl_object volatile v3;
   v3 = ecl_make_cfun((cl_objectfn_fixed)LC3598__lambda21,ECL_NIL,Cblock,2);
   T0 = v3;
  }
  si_put_sysprop(VV[16], VV[6], T0);
  {
   cl_object v3package;
   v3package = cl_symbol_package(VV[17]);
   if (Null(v3package)) { goto L65; }
   if (Null(si_package_locked_p(v3package))) { goto L65; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L65; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[14], ECL_SYM("PACKAGE",1318), v3package);
  }
L65:;
  {
   cl_object volatile v4;
   v4 = ecl_make_cfun((cl_objectfn_fixed)LC3599__lambda25,ECL_NIL,Cblock,2);
   T0 = v4;
  }
  si_put_sysprop(VV[17], VV[6], T0);
  {
   cl_object v4package;
   v4package = cl_symbol_package(VV[18]);
   if (Null(v4package)) { goto L73; }
   if (Null(si_package_locked_p(v4package))) { goto L73; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L73; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[15], ECL_SYM("PACKAGE",1318), v4package);
  }
L73:;
  {
   cl_object volatile v5;
   v5 = ecl_make_cfun((cl_objectfn_fixed)LC3600__lambda29,ECL_NIL,Cblock,2);
   T0 = v5;
  }
  si_put_sysprop(VV[18], VV[6], T0);
  {
   cl_object v5package;
   v5package = cl_symbol_package(VV[19]);
   if (Null(v5package)) { goto L81; }
   if (Null(si_package_locked_p(v5package))) { goto L81; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L81; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[16], ECL_SYM("PACKAGE",1318), v5package);
  }
L81:;
  {
   cl_object volatile v6;
   v6 = ecl_make_cfun((cl_objectfn_fixed)LC3601__lambda33,ECL_NIL,Cblock,2);
   T0 = v6;
  }
  si_put_sysprop(VV[19], VV[6], T0);
  {
   cl_object v6package;
   v6package = cl_symbol_package(VV[20]);
   if (Null(v6package)) { goto L89; }
   if (Null(si_package_locked_p(v6package))) { goto L89; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L89; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[17], ECL_SYM("PACKAGE",1318), v6package);
  }
L89:;
  {
   cl_object volatile v7;
   v7 = ecl_make_cfun((cl_objectfn_fixed)LC3602__lambda37,ECL_NIL,Cblock,2);
   T0 = v7;
  }
  si_put_sysprop(VV[20], VV[6], T0);
  {
   cl_object v7package;
   v7package = cl_symbol_package(VV[21]);
   if (Null(v7package)) { goto L97; }
   if (Null(si_package_locked_p(v7package))) { goto L97; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L97; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[18], ECL_SYM("PACKAGE",1318), v7package);
  }
L97:;
  {
   cl_object volatile v8;
   v8 = ecl_make_cfun((cl_objectfn_fixed)LC3603__lambda41,ECL_NIL,Cblock,2);
   T0 = v8;
  }
  si_put_sysprop(VV[21], VV[6], T0);
  {
   cl_object v8package;
   v8package = cl_symbol_package(VV[22]);
   if (Null(v8package)) { goto L105; }
   if (Null(si_package_locked_p(v8package))) { goto L105; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L105; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[19], ECL_SYM("PACKAGE",1318), v8package);
  }
L105:;
  {
   cl_object volatile v9;
   v9 = ecl_make_cfun((cl_objectfn_fixed)LC3604__lambda45,ECL_NIL,Cblock,2);
   T0 = v9;
  }
  si_put_sysprop(VV[22], VV[6], T0);
  {
   cl_object v9package;
   v9package = cl_symbol_package(VV[23]);
   if (Null(v9package)) { goto L113; }
   if (Null(si_package_locked_p(v9package))) { goto L113; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L113; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[20], ECL_SYM("PACKAGE",1318), v9package);
  }
L113:;
  {
   cl_object volatile v10;
   v10 = ecl_make_cfun((cl_objectfn_fixed)LC3605__lambda49,ECL_NIL,Cblock,2);
   T0 = v10;
  }
  si_put_sysprop(VV[23], VV[6], T0);
  {
   cl_object v10package;
   v10package = cl_symbol_package(VV[24]);
   if (Null(v10package)) { goto L121; }
   if (Null(si_package_locked_p(v10package))) { goto L121; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1123))==ECL_NIL)) { goto L121; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[3], VVtemp[4], VVtemp[21], ECL_SYM("PACKAGE",1318), v10package);
  }
L121:;
  {
   cl_object volatile v11;
   v11 = ecl_make_cfun((cl_objectfn_fixed)LC3606__lambda53,ECL_NIL,Cblock,2);
   T0 = v11;
  }
  si_put_sysprop(VV[24], VV[6], T0);
 }
  ecl_cmp_defun(VV[79]);                          /*  LISP-TYPE-P     */
  ecl_cmp_defun(VV[80]);                          /*  REP-TYPE-RECORD-UNSAFE */
  ecl_cmp_defun(VV[81]);                          /*  REP-TYPE-RECORD */
  ecl_cmp_defun(VV[83]);                          /*  REP-TYPE->LISP-TYPE */
  ecl_cmp_defun(VV[84]);                          /*  LISP-TYPE->REP-TYPE */
  ecl_cmp_defun(VV[85]);                          /*  C-NUMBER-REP-TYPE-P */
  ecl_cmp_defun(VV[86]);                          /*  C-INTEGER-REP-TYPE-P */
  ecl_cmp_defun(VV[87]);                          /*  C-INTEGER-REP-TYPE-BITS */
  ecl_cmp_defun(VV[88]);                          /*  C-NUMBER-TYPE-P */
  ecl_cmp_defun(VV[89]);                          /*  C-INTEGER-TYPE-P */
  ecl_cmp_defun(VV[90]);                          /*  C-INTEGER-TYPE-BITS */
  ecl_cmp_defun(VV[92]);                          /*  REP-TYPE->C-NAME */
  si_Xmake_constant(VV[40], VVtemp[22]);
  si_Xmake_constant(VV[41], VVtemp[23]);
  si_Xmake_constant(VV[42], VVtemp[24]);
  ecl_cmp_defun(VV[93]);                          /*  MAKE-REP-TYPE   */
  ecl_cmp_defun(VV[94]);                          /*  DEFAULT-MACHINE */
  ecl_cmp_defun(VV[95]);                          /*  MACHINE-C-TYPE-P */
  ecl_cmp_defun(VV[96]);                          /*  MACHINE-FIXNUMP */
  si_Xmake_special(VV[61]);
  if (ecl_boundp(cl_env_copy,VV[61])) { goto L191; }
  cl_set(VV[26],L3620default_machine());
  cl_set(VV[61],ecl_symbol_value(VV[26]));
L191:;
}
