/*      Compiler: ECL 24.5.10                                         */
/*      Source: /home/abuild/rpmbuild/BUILD/ecl-24.5.10/src/cmp/cmpfun.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmpfun.eclh"
/*      function definition for CHILD-FUNCTION-P                      */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object L3362child_function_p(cl_object v1presumed_parent, cl_object v2fun)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3real_parent;
   v3real_parent = ECL_NIL;
L2:;
   v3real_parent = ecl_function_dispatch(cl_env_copy,VV[26])(1, v2fun) /*  FUN-PARENT */;
   if ((v3real_parent)!=ECL_NIL) { goto L6; }
   goto L3;
L6:;
   if (!((v3real_parent)==(v1presumed_parent))) { goto L9; }
   value0 = ECL_T;
   cl_env_copy->nvalues = 1;
   return value0;
L9:;
   v2fun = v3real_parent;
   goto L2;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for COMPUTE-CLOSURE-TYPE                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3363compute_closure_type(cl_object v1fun)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2lexical_closure_p;
   v2lexical_closure_p = ECL_NIL;
   {
    cl_object v3;
    v3 = ecl_function_dispatch(cl_env_copy,VV[27])(1, v1fun) /*  FUN-REFERENCED-VARS */;
    goto L6;
L5:;
    {
     cl_object v4var;
     v4var = ecl_car(v3);
     {
      cl_object v5;
      v5 = ecl_function_dispatch(cl_env_copy,VV[28])(1, v4var) /*  GLOBAL-VAR-P */;
      if (Null(v5)) { goto L12; }
      goto L10;
L12:;
      if (Null(ecl_function_dispatch(cl_env_copy,VV[29])(1, v4var) /*  REF-REF-CCB */)) { goto L14; }
      value0 = VV[1];
      cl_env_copy->nvalues = 1;
      return value0;
L14:;
      v2lexical_closure_p = ECL_T;
     }
L10:;
    }
    v3 = ecl_cdr(v3);
L6:;
    if (Null(v3)) { goto L19; }
    goto L5;
L19:;
   }
   {
    cl_object v3;
    v3 = ecl_function_dispatch(cl_env_copy,VV[30])(1, v1fun) /*  FUN-REFERENCED-FUNS */;
    goto L25;
L24:;
    {
     cl_object v4f;
     v4f = ecl_car(v3);
     if ((L3362child_function_p(v1fun, v4f))!=ECL_NIL) { goto L29; }
     {
      cl_object v5;
      v5 = ecl_function_dispatch(cl_env_copy,VV[31])(1, v4f) /*  FUN-CLOSURE */;
      if (!((v5)==(VV[1]))) { goto L32; }
      value0 = VV[1];
      cl_env_copy->nvalues = 1;
      return value0;
L32:;
      if (!((v5)==(VV[2]))) { goto L29; }
      v2lexical_closure_p = ECL_T;
     }
L29:;
    }
    v3 = ecl_cdr(v3);
L25:;
    if (Null(v3)) { goto L38; }
    goto L24;
L38:;
   }
   if (Null(v2lexical_closure_p)) { goto L40; }
   if ((ecl_function_dispatch(cl_env_copy,VV[32])(1, v1fun) /*  FUN-REF-CCB */)!=ECL_NIL) { goto L44; }
   if (Null(ecl_function_dispatch(cl_env_copy,VV[33])(1, v1fun) /*  FUN-VAR */)) { goto L42; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[33])(1, v1fun) /*  FUN-VAR */;
   T1 = ecl_function_dispatch(cl_env_copy,VV[34])(1, T0) /*  VAR-REF  */;
   if (!(ecl_plusp(T1))) { goto L42; }
   goto L43;
L44:;
L43:;
   value0 = VV[1];
   cl_env_copy->nvalues = 1;
   return value0;
L42:;
   value0 = VV[2];
   cl_env_copy->nvalues = 1;
   return value0;
L40:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for UPDATE-FUN-CLOSURE-TYPE-MANY          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3364update_fun_closure_type_many(cl_object v1function_list)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2finish;
   cl_object v3recompute;
   v2finish = ECL_NIL;
   v3recompute = ECL_NIL;
   goto L5;
L4:;
   {
    cl_object v4;
    v4 = v1function_list;
    goto L11;
L10:;
    {
     cl_object v5f;
     v5f = ecl_car(v4);
     if (Null(L3366update_fun_closure_type(v5f))) { goto L15; }
     v3recompute = ECL_T;
     v2finish = ECL_NIL;
L15:;
    }
    v4 = ecl_cdr(v4);
L11:;
    if (Null(v4)) { goto L22; }
    goto L10;
L22:;
   }
   v2finish = ECL_T;
L5:;
   if ((v2finish)!=ECL_NIL) { goto L26; }
   goto L4;
L26:;
   value0 = v3recompute;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for PREPEND-NEW                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3365prepend_new(cl_object v1l1, cl_object v2l2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3f;
   cl_object v4;
   v3f = ECL_NIL;
   {
    cl_object v5;
    v5 = v1l1;
    if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v4 = v5;
   }
L6:;
   if (!(ecl_endp(v4))) { goto L8; }
   goto L7;
L8:;
   v3f = ECL_CONS_CAR(v4);
   {
    cl_object v5;
    v5 = ECL_CONS_CDR(v4);
    if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v4 = v5;
   }
   v2l2 = cl_adjoin(2, v3f, v2l2);
   goto L6;
L7:;
  }
  value0 = v2l2;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for UPDATE-FUN-CLOSURE-TYPE               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3366update_fun_closure_type(cl_object v1fun)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2old_type;
   v2old_type = ecl_function_dispatch(cl_env_copy,VV[31])(1, v1fun) /*  FUN-CLOSURE */;
   if (!((v2old_type)==(VV[1]))) { goto L2; }
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
L2:;
   {
    cl_object v3;
    cl_object v4to_be_updated;
    v3 = L3363compute_closure_type(v1fun);
    v4to_be_updated = ECL_NIL;
    if (!((v3)==(v2old_type))) { goto L6; }
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    return value0;
L6:;
    if (Null(ecl_function_dispatch(cl_env_copy,VV[38])(1, v1fun) /*  FUN-GLOBAL */)) { goto L8; }
    T0 = ecl_function_dispatch(cl_env_copy,VV[39])(1, v1fun) /*  FUN-NAME */;
    {
     cl_object v5;
     v5 = ecl_fdefinition(VV[40]);
     {
      cl_object v6;
      cl_object v7;
      cl_object v8;
      v6 = ecl_function_dispatch(cl_env_copy,VV[27])(1, v1fun) /*  FUN-REFERENCED-VARS */;
      v7 = ECL_NIL;
      {
       cl_object v9;
       v9 = v6;
       if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v8 = v9;
      }
      {
       cl_object v9;
       cl_object v10;
       v9 = ecl_list1(ECL_NIL);
       v10 = v9;
L19:;
       if (!(ecl_endp(v8))) { goto L21; }
       goto L20;
L21:;
       v7 = ECL_CONS_CAR(v8);
       {
        cl_object v11;
        v11 = ECL_CONS_CDR(v8);
        if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v8 = v11;
       }
       {
        cl_object v11;
        v11 = v10;
        if (ecl_unlikely(ECL_ATOM(v11))) FEtype_error_cons(v11);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        T2 = v11;
       }
       T3 = ecl_function_dispatch(cl_env_copy,v5)(1, v7);
       v10 = ecl_list1(T3);
       (ECL_CONS_CDR(T2)=v10,T2);
       goto L19;
L20:;
       T1 = ecl_cdr(v9);
       goto L10;
      }
     }
    }
L10:;
    ecl_function_dispatch(cl_env_copy,VV[41])(3, VV[5], T0, T1) /*  CMPNOTE */;
L8:;
    T0 = ecl_function_dispatch(cl_env_copy,VV[42])(1, v1fun) /*  FUN-CHILD-FUNS */;
    T1 = ecl_function_dispatch(cl_env_copy,VV[43])(1, v1fun) /*  FUN-REFERENCING-FUNS */;
    v4to_be_updated = ecl_append(T0,T1);
    ecl_structure_set(v1fun,VV[6],12,v3);
    if (!((v3)==(VV[1]))) { goto L40; }
    {
     cl_object v5;
     v5 = ecl_function_dispatch(cl_env_copy,VV[27])(1, v1fun) /*  FUN-REFERENCED-VARS */;
     goto L46;
L45:;
     {
      cl_object v6var;
      v6var = ecl_car(v5);
      if ((ecl_function_dispatch(cl_env_copy,VV[28])(1, v6var) /*  GLOBAL-VAR-P */)!=ECL_NIL) { goto L50; }
      T0 = ecl_function_dispatch(cl_env_copy,VV[44])(1, v6var) /*  VAR-KIND */;
      if ((T0)==(v3)) { goto L50; }
      ecl_structure_set(v6var,VV[7],3,ECL_NIL);
      ecl_structure_set(v6var,VV[7],2,ECL_T);
      ecl_structure_set(v6var,VV[7],6,VV[1]);
      ecl_structure_set(v6var,VV[7],10,VV[8]);
      T0 = ecl_function_dispatch(cl_env_copy,VV[45])(1, v6var) /*  VAR-FUNCTIONS-READING */;
      T1 = ecl_function_dispatch(cl_env_copy,VV[46])(1, v6var) /*  VAR-FUNCTIONS-SETTING */;
      T2 = L3365prepend_new(T1, v4to_be_updated);
      v4to_be_updated = L3365prepend_new(T0, T2);
L50:;
     }
     v5 = ecl_cdr(v5);
L46:;
     if (Null(v5)) { goto L60; }
     goto L45;
L60:;
    }
    {
     cl_object v5;
     v5 = ecl_function_dispatch(cl_env_copy,VV[30])(1, v1fun) /*  FUN-REFERENCED-FUNS */;
     goto L65;
L64:;
     {
      cl_object v6f;
      v6f = ecl_car(v5);
      ecl_structure_set(v6f,VV[6],2,ECL_T);
     }
     v5 = ecl_cdr(v5);
L65:;
     if (Null(v5)) { goto L72; }
     goto L64;
L72:;
    }
L40:;
    if (Null(L3364update_fun_closure_type_many(v4to_be_updated))) { goto L74; }
    L3366update_fun_closure_type(v1fun);
L74:;
    value0 = ECL_T;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for LOCAL-FUNCTION-REF                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3367local_function_ref(cl_narg narg, cl_object v1fname, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2build_object;
  va_list args; va_start(args,v1fname);
  {
   int i = 1;
   if (i >= narg) {
    v2build_object = ECL_NIL;
   } else {
    i++;
    v2build_object = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v4;                                  /*  FUN             */
   cl_object v5;                                  /*  CFB             */
   value0 = ecl_function_dispatch(cl_env_copy,VV[48])(1, v1fname) /*  CMP-ENV-SEARCH-FUNCTION */;
   {
    const int v6 = cl_env_copy->nvalues;
    v4 = value0;
    cl_object v7;
    v7 = (v6<=1)? ECL_NIL : cl_env_copy->values[1];
    v5 = v7;
   }
   if (Null(v4)) { goto L3; }
   if (Null(cl_functionp(v4))) { goto L5; }
   if (Null(v2build_object)) { goto L7; }
   ecl_function_dispatch(cl_env_copy,VV[49])(2, VV[10], v1fname) /*  CMPERR */;
L7:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
L5:;
   {
    cl_object v6;
    T0 = ecl_function_dispatch(cl_env_copy,VV[50])(1, v4) /*  FUN-REF */;
    v6 = ecl_plus(T0,ecl_make_fixnum(1));
    ecl_structure_set(v4,VV[6],1,v6);
   }
   if (Null(v2build_object)) { goto L12; }
   ecl_structure_set(v4,VV[6],2,ECL_T);
   goto L11;
L12:;
   {
    cl_object v6caller;
    v6caller = ecl_symbol_value(VV[11]);
    if (Null(v6caller)) { goto L11; }
    {
     cl_object v7;
     cl_object v8;
     cl_object v9;
     cl_object v10;
     v7 = ecl_function_dispatch(cl_env_copy,VV[30])(1, v6caller) /*  FUN-REFERENCED-FUNS */;
     v8 = (ECL_SYM("EQ",335)->symbol.gfdef);
     v9 = v4;
     v10 = v7;
     if ((si_memq(v9,v10))!=ECL_NIL) { goto L11; }
    }
    {
     cl_object v7;
     T0 = ecl_function_dispatch(cl_env_copy,VV[30])(1, v6caller) /*  FUN-REFERENCED-FUNS */;
     v7 = CONS(v4,T0);
     ecl_structure_set(v6caller,VV[6],23,v7);
    }
    {
     cl_object v7;
     T0 = ecl_function_dispatch(cl_env_copy,VV[43])(1, v4) /*  FUN-REFERENCING-FUNS */;
     v7 = CONS(v6caller,T0);
     ecl_structure_set(v4,VV[6],24,v7);
    }
   }
L11:;
   {
    cl_object v6var;
    v6var = ecl_function_dispatch(cl_env_copy,VV[33])(1, v4) /*  FUN-VAR */;
    if (Null(v5)) { goto L3; }
    if (Null(v2build_object)) { goto L3; }
    ecl_structure_set(v6var,VV[7],3,ECL_T);
    T0 = ecl_function_dispatch(cl_env_copy,VV[44])(1, v6var) /*  VAR-KIND */;
    if ((T0)==(VV[1])) { goto L3; }
    ecl_structure_set(v6var,VV[7],6,VV[2]);
   }
L3:;
   value0 = v4;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for FUN-NEEDS-NARG                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3368fun_needs_narg(cl_object v1fun)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = L3369fun_fixed_narg(v1fun);
  value0 = Null(T0)?ECL_T:ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for FUN-FIXED-NARG                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3369fun_fixed_narg(cl_object v1fun)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2narg;
   v2narg = ECL_NIL;
   T0 = ecl_function_dispatch(cl_env_copy,VV[31])(1, v1fun) /*  FUN-CLOSURE */;
   if ((T0)==(VV[1])) { goto L3; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[53])(1, v1fun) /*  FUN-MINARG */;
   v2narg = ecl_function_dispatch(cl_env_copy,VV[54])(1, v1fun) /*  FUN-MAXARG */;
   if (!(ecl_number_equalp(T0,v2narg))) { goto L3; }
   if (!(ecl_lowereq(v2narg,ecl_make_fixnum(63)))) { goto L3; }
   value0 = v2narg;
   cl_env_copy->nvalues = 1;
   return value0;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for ADD-TO-FUN-REFERENCED-VARS            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3370add_to_fun_referenced_vars(cl_object v1fun, cl_object v2var_list)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3new_vars;
   v3new_vars = ecl_function_dispatch(cl_env_copy,VV[27])(1, v1fun) /*  FUN-REFERENCED-VARS */;
   {
    cl_object v4locals;
    v4locals = ecl_function_dispatch(cl_env_copy,VV[56])(1, v1fun) /*  FUN-LOCAL-VARS */;
    {
     cl_object v5change;
     v5change = ECL_NIL;
     {
      cl_object v6v;
      cl_object v7;
      v6v = ECL_NIL;
      {
       cl_object v8;
       v8 = v2var_list;
       if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v7 = v8;
      }
L8:;
      if (!(ecl_endp(v7))) { goto L10; }
      goto L9;
L10:;
      v6v = ECL_CONS_CAR(v7);
      {
       cl_object v8;
       v8 = ECL_CONS_CDR(v7);
       if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v7 = v8;
      }
      {
       cl_object v8;
       cl_object v9;
       cl_object v10;
       v8 = (ECL_SYM("EQ",335)->symbol.gfdef);
       v9 = v6v;
       v10 = v4locals;
       if ((si_memq(v9,v10))!=ECL_NIL) { goto L18; }
      }
      {
       cl_object v8;
       cl_object v9;
       cl_object v10;
       v8 = (ECL_SYM("EQ",335)->symbol.gfdef);
       v9 = v6v;
       v10 = v3new_vars;
       if ((si_memq(v9,v10))!=ECL_NIL) { goto L18; }
      }
      v5change = ECL_T;
      v3new_vars = CONS(v6v,v3new_vars);
L18:;
      goto L8;
L9:;
      if (Null(v5change)) { goto L31; }
      ecl_structure_set(v1fun,VV[6],22,v3new_vars);
      value0 = ECL_T;
      cl_env_copy->nvalues = 1;
      return value0;
L31:;
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 1;
      return value0;
     }
    }
   }
  }
 }
}
/*      function definition for ADD-TO-FUN-REFERENCED-FUNS            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3371add_to_fun_referenced_funs(cl_object v1fun, cl_object v2fun_list)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3new_funs;
   v3new_funs = ecl_function_dispatch(cl_env_copy,VV[30])(1, v1fun) /*  FUN-REFERENCED-FUNS */;
   {
    cl_object v4change;
    v4change = ECL_NIL;
    {
     cl_object v5f;
     cl_object v6;
     v5f = ECL_NIL;
     {
      cl_object v7;
      v7 = v2fun_list;
      if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v6 = v7;
     }
L7:;
     if (!(ecl_endp(v6))) { goto L9; }
     goto L8;
L9:;
     v5f = ECL_CONS_CAR(v6);
     {
      cl_object v7;
      v7 = ECL_CONS_CDR(v6);
      if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v6 = v7;
     }
     if ((v1fun)==(v5f)) { goto L17; }
     {
      cl_object v7;
      cl_object v8;
      cl_object v9;
      v7 = (ECL_SYM("EQ",335)->symbol.gfdef);
      v8 = v5f;
      v9 = v3new_funs;
      if ((si_memq(v8,v9))!=ECL_NIL) { goto L17; }
     }
     if ((L3362child_function_p(v1fun, v5f))!=ECL_NIL) { goto L17; }
     v4change = ECL_T;
     v3new_funs = CONS(v5f,v3new_funs);
     {
      cl_object v7;
      T0 = ecl_function_dispatch(cl_env_copy,VV[43])(1, v5f) /*  FUN-REFERENCING-FUNS */;
      v7 = CONS(v1fun,T0);
      ecl_structure_set(v5f,VV[6],24,v7);
     }
L17:;
     goto L7;
L8:;
     if (Null(v4change)) { goto L30; }
     ecl_structure_set(v1fun,VV[6],23,v3new_funs);
     value0 = ECL_T;
     cl_env_copy->nvalues = 1;
     return value0;
L30:;
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
}
/*      function definition for FUNCTION-BLOCK-NAME-DECLARATION       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3372function_block_name_declaration(cl_object v1declarations)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2i;
   cl_object v3;
   v2i = ECL_NIL;
   {
    cl_object v4;
    v4 = v1declarations;
    if (ecl_unlikely(!ECL_LISTP(v4))) FEtype_error_list(v4);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v3 = v4;
   }
L5:;
   if (!(ecl_endp(v3))) { goto L7; }
   goto L6;
L7:;
   v2i = ECL_CONS_CAR(v3);
   {
    cl_object v4;
    v4 = ECL_CONS_CDR(v3);
    if (ecl_unlikely(!ECL_LISTP(v4))) FEtype_error_list(v4);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v3 = v4;
   }
   if (!(ECL_CONSP(v2i))) { goto L15; }
   T0 = ecl_car(v2i);
   if (!((T0)==(ECL_SYM("FUNCTION-BLOCK-NAME",1088)))) { goto L15; }
   T0 = ecl_cdr(v2i);
   if (!(ECL_CONSP(T0))) { goto L15; }
   value0 = ecl_cadr(v2i);
   cl_env_copy->nvalues = 1;
   return value0;
L15:;
   goto L5;
L6:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for EXPORTED-FNAME                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3373exported_fname(cl_object v1name)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2cname;
   v2cname = ECL_NIL;
   if (!(ECL_SYMBOLP(v1name))) { goto L2; }
   v2cname = si_get_sysprop(v1name, VV[18]);
   if (Null(v2cname)) { goto L2; }
   cl_env_copy->nvalues = 2;
   cl_env_copy->values[1] = ECL_T;
   cl_env_copy->values[0] = v2cname;
   return cl_env_copy->values[0];
L2:;
   T0 = ecl_function_dispatch(cl_env_copy,VV[60])(2, VV[19], v1name) /*  NEXT-CFUN */;
   cl_env_copy->nvalues = 2;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = T0;
   return cl_env_copy->values[0];
  }
 }
}
/*      function definition for FUNCTION-MAY-HAVE-SIDE-EFFECTS        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3374function_may_have_side_effects(cl_object v1fname)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = si_get_sysprop(v1fname, VV[21]);
  value0 = Null(T0)?ECL_T:ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for FUNCTION-MAY-CHANGE-SP                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3375function_may_change_sp(cl_object v1fname)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = si_get_sysprop(v1fname, VV[21]);
  if ((value0)!=ECL_NIL) { goto L3; }
  T0 = si_get_sysprop(v1fname, VV[23]);
  goto L1;
L3:;
  T0 = value0;
  goto L1;
L1:;
  value0 = Null(T0)?ECL_T:ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}

#include "cmp/cmpfun.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclrllw5SGHSV7k9_FWCzvY71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPFUN.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclrllw5SGHSV7k9_FWCzvY71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  ecl_cmp_defun(VV[25]);                          /*  CHILD-FUNCTION-P */
  (void)0; /* No entry created for COMPUTE-CLOSURE-TYPE */
  ecl_cmp_defun(VV[35]);                          /*  UPDATE-FUN-CLOSURE-TYPE-MANY */
  ecl_cmp_defun(VV[36]);                          /*  PREPEND-NEW     */
  ecl_cmp_defun(VV[37]);                          /*  UPDATE-FUN-CLOSURE-TYPE */
  ecl_cmp_defun(VV[47]);                          /*  LOCAL-FUNCTION-REF */
  ecl_cmp_defun(VV[51]);                          /*  FUN-NEEDS-NARG  */
  ecl_cmp_defun(VV[52]);                          /*  FUN-FIXED-NARG  */
  ecl_cmp_defun(VV[55]);                          /*  ADD-TO-FUN-REFERENCED-VARS */
  ecl_cmp_defun(VV[57]);                          /*  ADD-TO-FUN-REFERENCED-FUNS */
  ecl_cmp_defun(VV[58]);                          /*  FUNCTION-BLOCK-NAME-DECLARATION */
  ecl_cmp_defun(VV[59]);                          /*  EXPORTED-FNAME  */
  ecl_cmp_defun(VV[61]);                          /*  FUNCTION-MAY-HAVE-SIDE-EFFECTS */
  ecl_cmp_defun(VV[62]);                          /*  FUNCTION-MAY-CHANGE-SP */
}
