/*      Compiler: ECL 24.5.10                                         */
/*      Source: /home/abuild/rpmbuild/BUILD/ecl-24.5.10/src/cmp/cmppass1-data.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmppass1-data.eclh"
/*      function definition for DATA-PERMANENT-STORAGE-SIZE           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3399data_permanent_storage_size()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_make_fixnum(ecl_length(ecl_symbol_value(VV[0])));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for DATA-TEMPORARY-STORAGE-SIZE           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3400data_temporary_storage_size()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_make_fixnum(ecl_length(ecl_symbol_value(VV[2])));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for DATA-SIZE                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3401data_size()
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = L3399data_permanent_storage_size();
  T1 = L3400data_temporary_storage_size();
  value0 = ecl_plus(T0,T1);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for DATA-INIT                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3402data_init(volatile cl_narg narg, ...)
{
 cl_object volatile env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg>1)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v1filename;
  va_list args; va_start(args,narg);
  {
   int i = 0;
   if (i >= narg) {
    v1filename = ECL_NIL;
   } else {
    i++;
    v1filename = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if (Null(v1filename)) { goto L2; }
  if (Null(cl_probe_file(v1filename))) { goto L2; }
  {
   volatile cl_object v2s;
   v2s = cl_open(3, v1filename, ECL_SYM("DIRECTION",1246), ECL_SYM("INPUT",1286));
   {
    volatile bool unwinding = FALSE;
    cl_index v3=ECL_STACK_INDEX(cl_env_copy),v4;
    ecl_frame_ptr next_fr;
    ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
    if (__ecl_frs_push_result) {
      unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
    } else {
    {
     struct ecl_stack_frame _ecl_inner_frame_aux;
     volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
     {
      cl_object v5;
      v5 = _ecl_inner_frame;
      cl_set(VV[0],cl_read(1, v2s));
      cl_set(VV[2],cl_read(1, v2s));
      cl_env_copy->values[0] = ecl_symbol_value(VV[2]);
      cl_env_copy->nvalues = 1;
      ecl_stack_frame_push_values(v5);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      if (Null(v2s)) { goto L14; }
      cl_close(1, v2s);
L14:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v5);
     }
     ecl_stack_frame_close(_ecl_inner_frame);
    }
    }
    ecl_frs_pop(cl_env_copy);
    v4=ecl_stack_push_values(cl_env_copy);
    if (Null(v2s)) { goto L16; }
    cl_close(3, v2s, ECL_SYM("ABORT",1222), ECL_T);
L16:;
    ecl_stack_pop_values(cl_env_copy,v4);
    if (unwinding) ecl_unwind(cl_env_copy,next_fr);
    ECL_STACK_SET_INDEX(cl_env_copy,v3);
    return cl_env_copy->values[0];
   }
  }
L2:;
  cl_set(VV[0],si_make_vector(ECL_T, ecl_make_fixnum(128), ECL_T, ecl_make_fixnum(0), ECL_NIL, ecl_make_fixnum(0)));
  cl_set(VV[2],si_make_vector(ECL_T, ecl_make_fixnum(128), ECL_T, ecl_make_fixnum(0), ECL_NIL, ecl_make_fixnum(0)));
  value0 = ecl_symbol_value(VV[2]);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for DATA-GET-ALL-OBJECTS                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3403data_get_all_objects()
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1;
   cl_object v2array;
   cl_object v3;
   v1 = cl_list(2, ecl_symbol_value(VV[0]), ecl_symbol_value(VV[2]));
   v2array = ECL_NIL;
   v3 = v1;
   {
    cl_object v4;
    cl_object v5;
    v4 = ecl_list1(ECL_NIL);
    v5 = v4;
L6:;
    if (!(ecl_endp(v3))) { goto L8; }
    goto L7;
L8:;
    v2array = ECL_CONS_CAR(v3);
    {
     cl_object v6;
     v6 = ECL_CONS_CDR(v3);
     if (ecl_unlikely(!ECL_LISTP(v6))) FEtype_error_list(v6);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v3 = v6;
    }
    {
     cl_object v6;
     {
      cl_object v7vv_record;
      cl_object v8;
      cl_fixnum v9;
      cl_fixnum v10;
      v7vv_record = ECL_NIL;
      {
       cl_object v11;
       v11 = v2array;
       if (ecl_unlikely(!ECL_VECTORP(v11))) FEtype_error_vector(v11);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v8 = v11;
      }
      v9 = 0;
      v10 = 0;
      {
       cl_object v11object;
       v11object = ECL_NIL;
       {
        cl_object v12;
        cl_object v13;
        v12 = ecl_list1(ECL_NIL);
        v13 = v12;
        v10 = ecl_length(v8);
L28:;
        if (!((v9)>=(v10))) { goto L32; }
        goto L29;
L32:;
        {
         cl_object v14;
         v14 = v8;
         T0 = v14;
         {
          cl_fixnum v15;
          {
          cl_fixnum v16;
          v16 = v9;
          if (ecl_unlikely((v16)>=(v14)->vector.dim))
           FEwrong_index(ECL_NIL,v14,-1,ecl_make_fixnum(v16),(v14)->vector.dim);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          v15 = v16;
          }
          v7vv_record = ecl_aref_unsafe(T0,v15);
         }
        }
        {
         cl_object v14;
         v14 = ecl_make_integer((v9)+1);
         {
          bool v15;
          v15 = ECL_FIXNUMP(v14);
          if (ecl_unlikely(!(v15)))
         FEwrong_type_argument(ECL_SYM("FIXNUM",374),v14);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
         }
         v9 = ecl_fixnum(v14);
        }
        v11object = ecl_function_dispatch(cl_env_copy,VV[39])(1, v7vv_record) /*  VV-VALUE */;
        {
         cl_object v14;
         v14 = v13;
         if (ecl_unlikely(ECL_ATOM(v14))) FEtype_error_cons(v14);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         T0 = v14;
        }
        if (Null(ecl_gethash_safe(v11object,ecl_symbol_value(VV[6]),ECL_NIL))) { goto L53; }
        T1 = ecl_make_fixnum(0);
        goto L52;
L53:;
        if (Null(ecl_function_dispatch(cl_env_copy,VV[40])(1, v7vv_record) /*  VV-USED-P */)) { goto L55; }
        T1 = v11object;
        goto L52;
L55:;
        T1 = ecl_make_fixnum(0);
L52:;
        v13 = ecl_list1(T1);
        (ECL_CONS_CDR(T0)=v13,T0);
        goto L28;
L29:;
        v6 = ecl_cdr(v12);
        goto L18;
       }
      }
     }
L18:;
     {
      cl_object v7;
      v7 = v5;
      if (ecl_unlikely(ECL_ATOM(v7))) FEtype_error_cons(v7);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T0 = v7;
     }
     (ECL_CONS_CDR(T0)=v6,T0);
     if (Null(v6)) { goto L16; }
    }
    T0 = ecl_cdr(v5);
    v5 = ecl_last(T0,1);
L16:;
    goto L6;
L7:;
    value0 = ecl_cdr(v4);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for ADD-LOAD-FORM                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3406add_load_form(cl_object volatile v1object, cl_object volatile v2location)
{
 cl_object T0, T1;
 volatile cl_object lex0[2];
 cl_object volatile env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  lex0[0] = v2location;                           /*  LOCATION        */
TTL:
  if ((ecl_symbol_value(VV[8]))==(VV[9])) { goto L1; }
  ecl_function_dispatch(cl_env_copy,VV[42])(3, VV[10], v1object, ecl_symbol_value(VV[8])) /*  CMPERR */;
L1:;
  {
   cl_object volatile v4;                         /*  MAKE-FORM       */
   value0 = (cl_env_copy->function=(ECL_SYM("MAKE-LOAD-FORM",953)->symbol.gfdef))->cfun.entry(1, v1object) /*  MAKE-LOAD-FORM */;
   {
    const int v5 = cl_env_copy->nvalues;
    v4 = value0;
    cl_object v6;
    v6 = (v5<=1)? ECL_NIL : cl_env_copy->values[1];
    lex0[1] = v6;                                 /*  INIT-FORM       */
   }
   si_hash_set(v1object, ecl_symbol_value(VV[6]), lex0[0]);
   {
    volatile cl_object v5deferred;
    v5deferred = ECL_NIL;
    if (Null(v4)) { goto L6; }
    {
     cl_object v6;
     v6 = CONS(v1object,ecl_symbol_value(VV[11]));
     ecl_bds_bind(cl_env_copy,VV[12],ECL_NIL);    /*  *OBJECTS-INIT-DEFERRED* */
     ecl_bds_bind(cl_env_copy,VV[11],v6);         /*  *OBJECTS-BEING-CREATED* */
     T0 = ecl_function_dispatch(cl_env_copy,VV[43])(1, v4) /*  C1EXPR */;
     T1 = ecl_function_dispatch(cl_env_copy,VV[44])(4, VV[14], VV[15], lex0[0], T0) /*  MAKE-C1FORM* */;
     cl_set(VV[13],CONS(T1,ecl_symbol_value(VV[13])));
     v5deferred = cl_nreverse(ecl_symbol_value(VV[12]));
     ecl_bds_unwind1(cl_env_copy);
     ecl_bds_unwind1(cl_env_copy);
    }
L6:;
    {
     cl_object v6loc;
     cl_object v7init;
     cl_object v8;
     v6loc = ECL_NIL;
     v7init = ECL_NIL;
     {
      cl_object v9;
      v9 = v5deferred;
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v8 = v9;
     }
L17:;
     if (!(ecl_endp(v8))) { goto L19; }
     goto L18;
L19:;
     {
      cl_object v9;
      v9 = ECL_CONS_CAR(v8);
      v6loc = ecl_car(v9);
      v9 = ecl_cdr(v9);
      v7init = v9;
     }
     {
      cl_object v9;
      v9 = ECL_CONS_CDR(v8);
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v8 = v9;
     }
     LC3405maybe_init(lex0, v6loc, v7init);
     goto L17;
L18:;
     if (Null(lex0[1])) { goto L34; }
     LC3405maybe_init(lex0, lex0[0], lex0[1]);
L34:;
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
}
/*      local function MAYBE-INIT                                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3405maybe_init(volatile cl_object *lex0, cl_object volatile v1loc, cl_object volatile v2init)
{
 cl_object T0, T1, T2, T3;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   volatile cl_object env1 = env0;
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(ECL_NIL,env1);
   {
    volatile cl_object env2 = env1;
    CLV1 = env2 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env2); /*  TAGBODY */
    {
     ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV1));
     if (__ecl_frs_push_result) {
     if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L1;
     ecl_internal_error("GO found an inexistent tag");
     }
    }
    {
     cl_object v3;
     v3 = ecl_make_cclosure_va((cl_objectfn)LC3404__lambda63,env2,Cblock,1);
     T0 = v3;
    }
    T1 = CONS(VV[16],T0);
    T2 = ecl_list1(T1);
    T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
    ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T3); /*  *HANDLER-CLUSTERS* */
    T0 = ecl_function_dispatch(cl_env_copy,VV[43])(1, v2init) /*  C1EXPR */;
    T1 = ecl_function_dispatch(cl_env_copy,VV[44])(4, VV[17], VV[15], v1loc, T0) /*  MAKE-C1FORM* */;
    cl_set(VV[13],CONS(T1,ecl_symbol_value(VV[13])));
    value0 = ecl_symbol_value(VV[13]);
    cl_env_copy->nvalues = 1;
    ecl_frs_pop(cl_env_copy);
    ecl_bds_unwind1(cl_env_copy);
    return value0;
L1:;
    {
     cl_object v3c;
     v3c = ECL_CONS_CAR(CLV0);
     if (Null(ecl_symbol_value(VV[11]))) { goto L7; }
     T0 = CONS(lex0[0],lex0[1]);
     cl_set(VV[12],CONS(T0,ecl_symbol_value(VV[12])));
     value0 = ecl_symbol_value(VV[12]);
     cl_env_copy->nvalues = 1;
     ecl_frs_pop(cl_env_copy);
     return value0;
L7:;
     value0 = cl_error(1, v3c);
     ecl_frs_pop(cl_env_copy);
     return value0;
    }
   }
  }
 }
}
/*      closure LAMBDA63                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3404__lambda63(cl_narg narg, cl_object v1si__temp, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  TAGBODY         */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  ECL_CONS_CAR(CLV0) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV1),ecl_make_fixnum(0));
 }
 }
}
/*      function definition for DATA-EMPTY-LOC                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3407data_empty_loc()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = L3409add_object(5, ecl_make_fixnum(0), VV[19], ECL_T, VV[20], ECL_T);
  return value0;
 }
}
/*      function definition for GET-OBJECT                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3408get_object(cl_narg narg, cl_object v1object, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2permanent;
  cl_object v3errorp;
  ecl_va_list args; ecl_va_start(args,v1object,narg,1);
  {
   cl_object keyvars[4];
   cl_parse_key(args,2,L3408get_objectkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v2permanent = keyvars[0];
   if (Null(keyvars[3])) {
    v3errorp = ECL_T;
   } else {
    v3errorp = keyvars[1];
   }
  }
  {
   cl_object v4test;
   cl_object v5item;
   if (Null(ecl_symbol_value(ECL_SYM("*COMPILER-CONSTANTS*",1019)))) { goto L3; }
   v4test = ECL_SYM("EQ",335);
   goto L2;
L3:;
   v4test = VV[22];
L2:;
   if (Null(v2permanent)) { goto L6; }
   {
    cl_object v6;
    cl_object v7;
    v6 = ecl_symbol_value(VV[0]);
    v7 = ecl_fdefinition(VV[39]);
    {
     cl_object v8;
     v8 = ecl_function_dispatch(cl_env_copy,VV[49])(2, v6, ecl_make_fixnum(0)) /*  MAKE-SEQ-ITERATOR */;
L11:;
     if ((v8)!=ECL_NIL) { goto L13; }
     v5item = ECL_NIL;
     goto L5;
L13:;
     {
      cl_object v9;
      v9 = ecl_function_dispatch(cl_env_copy,VV[50])(2, v6, v8) /*  SEQ-ITERATOR-REF */;
      T0 = ecl_function_dispatch(cl_env_copy,VV[39])(1, v9) /*  VV-VALUE */;
      if (Null(ecl_function_dispatch(cl_env_copy,v4test)(2, v1object, T0))) { goto L15; }
      v5item = v9;
      goto L5;
     }
L15:;
     v8 = ecl_function_dispatch(cl_env_copy,VV[51])(2, v6, v8) /*  SEQ-ITERATOR-NEXT */;
     goto L11;
    }
   }
L6:;
   {
    cl_object v9;
    cl_object v10;
    v9 = ecl_symbol_value(VV[0]);
    v10 = ecl_fdefinition(VV[39]);
    {
     cl_object v11;
     v11 = ecl_function_dispatch(cl_env_copy,VV[49])(2, v9, ecl_make_fixnum(0)) /*  MAKE-SEQ-ITERATOR */;
L27:;
     if ((v11)!=ECL_NIL) { goto L29; }
     value0 = ECL_NIL;
     goto L23;
L29:;
     {
      cl_object v12;
      v12 = ecl_function_dispatch(cl_env_copy,VV[50])(2, v9, v11) /*  SEQ-ITERATOR-REF */;
      T0 = ecl_function_dispatch(cl_env_copy,VV[39])(1, v12) /*  VV-VALUE */;
      if (Null(ecl_function_dispatch(cl_env_copy,v4test)(2, v1object, T0))) { goto L31; }
      value0 = v12;
      goto L23;
     }
L31:;
     v11 = ecl_function_dispatch(cl_env_copy,VV[51])(2, v9, v11) /*  SEQ-ITERATOR-NEXT */;
     goto L27;
    }
   }
L23:;
   if ((value0)!=ECL_NIL) { goto L22; }
   {
    cl_object v9;
    cl_object v10;
    v9 = ecl_symbol_value(VV[2]);
    v10 = ecl_fdefinition(VV[39]);
    {
     cl_object v11;
     v11 = ecl_function_dispatch(cl_env_copy,VV[49])(2, v9, ecl_make_fixnum(0)) /*  MAKE-SEQ-ITERATOR */;
L40:;
     if ((v11)!=ECL_NIL) { goto L42; }
     v5item = ECL_NIL;
     goto L5;
L42:;
     {
      cl_object v12;
      v12 = ecl_function_dispatch(cl_env_copy,VV[50])(2, v9, v11) /*  SEQ-ITERATOR-REF */;
      T0 = ecl_function_dispatch(cl_env_copy,VV[39])(1, v12) /*  VV-VALUE */;
      if (Null(ecl_function_dispatch(cl_env_copy,v4test)(2, v1object, T0))) { goto L44; }
      v5item = v12;
      goto L5;
     }
L44:;
     v11 = ecl_function_dispatch(cl_env_copy,VV[51])(2, v9, v11) /*  SEQ-ITERATOR-NEXT */;
     goto L40;
    }
   }
L22:;
   v5item = value0;
   goto L5;
L5:;
   if (!(v5item==ECL_NIL)) { goto L50; }
   if (Null(v3errorp)) { goto L50; }
   ecl_function_dispatch(cl_env_copy,VV[42])(2, VV[23], v1object) /*  CMPERR */;
L50:;
   value0 = v5item;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for ADD-OBJECT                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3409add_object(cl_narg narg, cl_object v1object, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2duplicate;
  cl_object v3used_p;
  cl_object v4permanent;
  ecl_va_list args; ecl_va_start(args,v1object,narg,1);
  {
   cl_object keyvars[6];
   cl_parse_key(args,3,L3409add_objectkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v2duplicate = keyvars[0];
   v3used_p = keyvars[1];
   if (Null(keyvars[5])) {
    value0 = ecl_make_bool(ECL_SYMBOLP(v1object));
    if ((value0)!=ECL_NIL) { goto L3; }
    v4permanent = ecl_symbol_value(VV[25]);
    goto L1;
L3:;
    v4permanent = value0;
    goto L1;
L1:;
   } else {
    v4permanent = keyvars[2];
   }
  }
  {
   cl_object v5load_form_p;
   v5load_form_p = ECL_NIL;
   {
    cl_object v6vv;
    v6vv = ecl_function_dispatch(cl_env_copy,VV[56])(1, v1object) /*  ADD-STATIC-CONSTANT */;
    if (Null(v6vv)) { goto L6; }
    if (Null(v3used_p)) { goto L9; }
    ecl_structure_set(v6vv,VV[26],1,ECL_T);
L9:;
    value0 = v6vv;
    cl_env_copy->nvalues = 1;
    return value0;
   }
L6:;
   if (!(ecl_symbol_value(ECL_SYM("*COMPILER-CONSTANTS*",1019))==ECL_NIL)) { goto L11; }
   if (Null(si_need_to_make_load_form_p(v1object))) { goto L11; }
   v5load_form_p = ECL_T;
   v4permanent = ECL_T;
L11:;
   {
    cl_object v6item;
    cl_object v7array;
    cl_object v8vv;
    v6item = L3408get_object(5, v1object, VV[20], v4permanent, VV[27], ECL_NIL);
    if (Null(v4permanent)) { goto L19; }
    v7array = ecl_symbol_value(VV[0]);
    goto L18;
L19:;
    v7array = ecl_symbol_value(VV[2]);
L18:;
    if (Null(v6item)) { goto L22; }
    if (Null(v2duplicate)) { goto L22; }
    {
     cl_fixnum v9ndx;
     cl_object v10vv;
     v9ndx = ecl_length(v7array);
     v10vv = ecl_function_dispatch(cl_env_copy,VV[57])(6, ECL_SYM("LOCATION",1001), ecl_make_fixnum(v9ndx), VV[28], v4permanent, ECL_SYM("VALUE",2066), v1object) /*  MAKE-VV */;
     {
      cl_fixnum v11;
      cl_fixnum v12;
      v11 = ((v7array)->vector.fillp);
      v12 = ((v7array)->array.dim);
      if (!((v11)<(v12))) { goto L31; }
      {
       cl_fixnum v13;
       v13 = (1)+(v11);
       ((v7array)->vector.fillp)=(v13);
      }
      ecl_aset_unsafe(v7array,v11,v10vv);
      goto L27;
L31:;
      cl_vector_push_extend(2, v10vv, v7array);
     }
L27:;
     v8vv = v10vv;
     goto L21;
    }
L22:;
    if (Null(v6item)) { goto L35; }
    {
     cl_object v11;
     cl_object v12;
     cl_object v13;
     v11 = ecl_symbol_value(VV[11]);
     v12 = v1object;
     v13 = v11;
     if (Null(ecl_memql(v12,v13))) { goto L37; }
    }
    cl_error(3, VV[16], VV[29], v1object);
L37:;
    v8vv = v6item;
    goto L21;
L35:;
    {
     cl_object v11;
     if ((v6item)!=ECL_NIL) { goto L44; }
     if ((v2duplicate)!=ECL_NIL) { goto L44; }
     if (!(ECL_SYMBOLP(v1object))) { goto L44; }
     {
      cl_object v13;                              /*  FOUNDP          */
      cl_object v14;                              /*  SYMBOL          */
      value0 = si_mangle_name(1, v1object);
      {
       const int v15 = cl_env_copy->nvalues;
       v13 = value0;
       cl_object v16;
       v16 = (v15<=1)? ECL_NIL : cl_env_copy->values[1];
       v14 = v16;
      }
      if (Null(v13)) { goto L50; }
      value0 = v14;
      cl_env_copy->nvalues = 1;
      return value0;
L50:;
      v11 = ECL_NIL;
      goto L42;
     }
L44:;
     v11 = ECL_NIL;
     goto L42;
L42:;
     if (Null(v11)) { goto L52; }
     v8vv = v11;
     goto L21;
L52:;
     {
      cl_fixnum v12ndx;
      cl_object v13vv;
      v12ndx = ecl_length(v7array);
      v13vv = ecl_function_dispatch(cl_env_copy,VV[57])(6, ECL_SYM("LOCATION",1001), ecl_make_fixnum(v12ndx), VV[28], v4permanent, ECL_SYM("VALUE",2066), v1object) /*  MAKE-VV */;
      {
       cl_fixnum v14;
       cl_fixnum v15;
       v14 = ((v7array)->vector.fillp);
       v15 = ((v7array)->array.dim);
       if (!((v14)<(v15))) { goto L60; }
       {
        cl_fixnum v16;
        v16 = (1)+(v14);
        ((v7array)->vector.fillp)=(v16);
       }
       ecl_aset_unsafe(v7array,v14,v13vv);
       goto L56;
L60:;
       cl_vector_push_extend(2, v13vv, v7array);
      }
L56:;
      if (Null(v5load_form_p)) { goto L64; }
      L3406add_load_form(v1object, v13vv);
L64:;
      v8vv = v13vv;
     }
    }
L21:;
    if ((v2duplicate)!=ECL_NIL) { goto L68; }
    if (Null(v3used_p)) { goto L66; }
    goto L67;
L68:;
L67:;
    ecl_structure_set(v8vv,VV[26],1,ECL_T);
L66:;
    value0 = v8vv;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for ADD-SYMBOL                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3410add_symbol(cl_object v1symbol)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = L3409add_object(5, v1symbol, VV[19], ECL_NIL, VV[20], ECL_T);
  return value0;
 }
}
/*      function definition for ADD-KEYWORDS                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3412add_keywords(cl_object v1keywords)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2x;
   {
    cl_object v3;
    v3 = ecl_make_cfun((cl_objectfn_fixed)LC3411__lambda156,ECL_NIL,Cblock,2);
    T0 = v3;
   }
   v2x = cl_search(4, v1keywords, ecl_symbol_value(VV[0]), ECL_SYM("TEST",1350), T0);
   if (Null(v2x)) { goto L3; }
   value0 = ecl_elt(ecl_symbol_value(VV[0]),ecl_to_size(v2x));
   cl_env_copy->nvalues = 1;
   return value0;
L3:;
   {
    cl_object v3;
    {
     cl_object v4;
     v4 = v1keywords;
     {
      cl_object v5;
      v5 = v4;
      {
       bool v6;
       v6 = ECL_LISTP(v5);
       if (ecl_unlikely(!(v6)))
         FEwrong_type_argument(VV[32],v5);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
      }
     }
     if (Null(v4)) { goto L11; }
     {
      cl_object v5;
      v5 = ECL_CONS_CDR(v4);
      v1keywords = v5;
      v4 = ECL_CONS_CAR(v4);
     }
L11:;
     T0 = v4;
    }
    v3 = L3409add_object(5, T0, VV[19], ECL_T, VV[20], ECL_T);
    {
     cl_object v4;
     v4 = v1keywords;
     goto L21;
L20:;
     {
      cl_object v5k;
      v5k = ecl_car(v4);
      L3409add_object(5, v5k, VV[19], ECL_T, VV[20], ECL_T);
     }
     v4 = ecl_cdr(v4);
L21:;
     if (Null(v4)) { goto L28; }
     goto L20;
L28:;
    }
    value0 = v3;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      local function LAMBDA156                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3411__lambda156(cl_object v1k, cl_object v2record)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_function_dispatch(cl_env_copy,VV[39])(1, v2record) /*  VV-VALUE */;
  value0 = ecl_make_bool((v1k)==(T0));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}

#include "cmp/cmppass1-data.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclggixxmVP9SAq9_G3JzvY71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPPASS1-DATA.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclggixxmVP9SAq9_G3JzvY71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  ecl_cmp_defun(VV[34]);                          /*  DATA-PERMANENT-STORAGE-SIZE */
  ecl_cmp_defun(VV[35]);                          /*  DATA-TEMPORARY-STORAGE-SIZE */
  ecl_cmp_defun(VV[36]);                          /*  DATA-SIZE       */
  ecl_cmp_defun(VV[37]);                          /*  DATA-INIT       */
  ecl_cmp_defun(VV[38]);                          /*  DATA-GET-ALL-OBJECTS */
  ecl_cmp_defun(VV[41]);                          /*  ADD-LOAD-FORM   */
  ecl_cmp_defun(VV[45]);                          /*  DATA-EMPTY-LOC  */
  ecl_cmp_defun(VV[46]);                          /*  GET-OBJECT      */
  ecl_cmp_defun(VV[52]);                          /*  ADD-OBJECT      */
  ecl_cmp_defun(VV[58]);                          /*  ADD-SYMBOL      */
  ecl_cmp_defun(VV[59]);                          /*  ADD-KEYWORDS    */
}
